#include <zasm/processor.h>
#include <zasm/list.h>
#include <zasm/tokens.h>
#include <zasm/errors.h>


static inline struct token_t pc_parser_0(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_1(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  while (1)
  {
    result = pc_parser_0(input,token,TOK_SPACE,TOK_NEWLINE);
    if (result.type == TOK_PC_FAIL)
    {
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_PC_SUCCESS;
      return result;
    }
  }
}
static inline 
struct token_t all_spaces_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_1(input,token);
}

static inline struct token_t pc_parser_2(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_3(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  pc_retval=pc_parser_2(input,token,TOK_SQUARE_OPEN);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=all_spaces_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
pc_retval.type=TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t square_open_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_3(input,token);
}

static inline struct token_t pc_parser_4(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_5(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;
  pc_retval=pc_parser_4(input,token,TOK_SQUARE_CLOSE);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  pc_retval=all_spaces_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
pc_retval.type=TOK_PC_SUCCESS;
    return pc_retval;
  
}
static inline 
struct token_t square_close_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_5(input,token);
}

static inline struct token_t pc_parser_6(struct feeder_t *input, struct token_t *token,int type1)
{
  struct token_t result;
  if ((token->type == type1))
    result.type = TOK_PC_FAIL1;
  else
  {
    result = *token;
    *token = feeder_get(input);
  }
  return result;
}

static inline struct token_t pc_parser_7(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  while (1)
  {
    result = pc_parser_6(input,token,TOK_SQUARE_CLOSE);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    list_add_end(list, result);
  }
}

static inline struct token_t pc_parser_8(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = square_open_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_7(input,token);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = square_close_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}
static inline 
struct token_t list_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_8(input,token);
}

static inline struct token_t pc_parser_9(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct proc_instr_arg_t *arg;
    struct token_t result;

    arg = proc_instr_arg_new();
      result=list_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
arg->pattern = result.value.t_struct_list_t_p;
    //    pc(all_spaces_p);
      result=list_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
arg->data = result.value.t_struct_list_t_p;
    //    pc(all_spaces_p);

    //    list_print(arg->pattern, stderr);
    //    list_print(arg->data, stderr);
    //    fprintf(stderr, "\n");

    result.type = TOK_PROC_INSTR_ARG;
    result.value.t_struct_proc_instr_arg_t_p = arg;
    return result;
  
}
static inline 
struct token_t argument_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_9(input,token);
}

static inline struct token_t pc_parser_10(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  while (1)
  {
    result = argument_p(input,token);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    list_add_end(list, result);
  }
}

static inline struct token_t pc_parser_11(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = square_open_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_10(input,token);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = square_close_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}
static inline 
struct token_t arguments_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_11(input,token);
}

static inline struct token_t pc_parser_12(struct feeder_t *input, struct token_t *token,int type)
{
  struct token_t result;
  if (token->type == type)
  {
    result = *token;
    *token = feeder_get(input);
  }
  else result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_13(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct proc_instr_t *instr;
    struct token_t result;

    instr = proc_instr_new();
      result=pc_parser_12(input,token,TOK_NAME);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
instr -> name = result.value.t_char_p;
      pc_retval=all_spaces_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  result=arguments_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
instr->arguments = result.value.t_struct_list_t_p;
      pc_retval=all_spaces_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
result.type = TOK_PROC_INSTR;
    result.value.t_struct_proc_instr_t_p = instr;
    return result;
  
}
static inline 
struct token_t instruction_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_13(input,token);
}

static inline struct token_t pc_parser_14(struct feeder_t *input, struct token_t *token)
{
  struct token_t result;
  struct list_t *list;
  list = list_new();
  while (1)
  {
    result = instruction_p(input,token);
    if (result.type == TOK_PC_FAIL)
    {
      list_free(list);
      return result;
    }
    if (result.type == TOK_PC_FAIL1)
    {
      result.type = TOK_LIST;
      result.value.t_struct_list_t_p = list;
      return result;
    }
    list_add_end(list, result);
  }
}

static inline struct token_t pc_parser_15(struct feeder_t *input, struct token_t *token)
{
  struct token_t result, retval;
  result = square_open_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
    return result;
  retval = pc_parser_14(input,token);
  if ((retval.type == TOK_PC_FAIL)||(retval.type == TOK_PC_FAIL1))
  {
    retval.type = TOK_PC_FAIL;
    return retval;
  }
  result = square_close_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    result.type = TOK_PC_FAIL;
    return result;
  }
  return retval;
}
static inline 
struct token_t instructions_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_15(input,token);
}

static inline struct token_t pc_parser_16(struct feeder_t *input, struct token_t *token,int type1,int type2)
{
  struct token_t result;
  if ((token->type == type1)||(token->type == type2))
  {
    result = *token;
    *token = feeder_get(input);
  }
  else
    result.type = TOK_PC_FAIL1;
  return result;
}

static inline struct token_t pc_parser_17(struct feeder_t *input, struct token_t *token){
  struct token_t pc_retval;
  int pc_called = 0;

    struct token_t result;
    struct processor_t *proc = NULL;
    
      pc_retval=all_spaces_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
proc = processor_new();
      result=pc_parser_16(input,token,TOK_LITTLE_ENDIAN,TOK_BIG_ENDIAN);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
if (result.type == TOK_LITTLE_ENDIAN)
      proc->endianness = PROC_LITTLE_ENDIAN;
    else
      proc->endianness = PROC_BIG_ENDIAN;
      pc_retval=all_spaces_p(input,token);
  if ((pc_retval.type == TOK_PC_FAIL)||(pc_retval.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      pc_retval.type = TOK_PC_FAIL;
    return pc_retval;
  }
  pc_called = 1;
  result=instructions_p(input,token);
  if ((result.type == TOK_PC_FAIL)||(result.type == TOK_PC_FAIL1))
  {
    if (pc_called)
      result.type = TOK_PC_FAIL;
    return result;
  }
  pc_called = 1;
proc->instruction_set = result.value.t_struct_list_t_p;
    result.type = TOK_PROCESSOR;
    result.value.t_struct_processor_t_p = proc;
    return result;
  
}

struct token_t processor_p(struct feeder_t *input, struct token_t *token)
{
  return pc_parser_17(input,token);
}














/*
__PARSER processor_p =
  {
    struct token_t t;
    pc_retval <- pc_between(square_open_p,square_close_p,pc_many(list_p));
    foreach(t,pc_retval.value.t_struct_list_t_p)
    {
      list_print(t.value.t_struct_list_t_p, stderr);
      fprintf(stderr, "\n");
    }
    pc_retval.type = TOK_PROCESSOR;
    return pc_retval;
  };
*/



