/* assembler tokens
#token struct mult_list_t TOK_MULT_LIST =
#token struct processor_t *TOK_PROCESSOR = 
#token struct proc_instr_t *TOK_PROC_INSTR =
#token struct proc_instr_arg_t *TOK_PROC_INSTR_ARG =
#token void TOK_LITTLE_ENDIAN = /"LITTLE ENDIAN"/ {} & {WRITE("LITTLE ENDIAN");}
#token void TOK_BIG_ENDIAN = /"BIG ENDIAN"/ {} & {WRITE("BIG ENDIAN");}
#token int TOK_BYTE_INT = /\\`[0-9a-fA-F]{2}\\`/ {$$ = strtol(yytext+1,NULL,16);} & {WRITE("`%02hhX`", $$);}
#token int TOK_WORD_INT = /\\`[0-9a-fA-F]{4}\\`/ {$$ = strtol(yytext+1,NULL,16);} & {WRITE("`%04hX`", $$);}
#token int TOK_DWORD_INT = /\\`[0-9a-fA-F]{8}\\`/ {$$ = strtol(yytext+1,NULL,16);} & {WRITE("`%08lX`", $$);}
#token int *TOK_BYTE_INT_P = & {WRITE("`%02hhX`", *($$));}
#token int *TOK_WORD_INT_P = & {WRITE("`%04hX`", *($$));}
#token int *TOK_DWORD_INT_P = & {WRITE("`%08lX`", *($$));}
#token void TOK_BYTE = /{DIR}byte/ {} & {WRITE("#byte ");}
#token void TOK_WORD = /{DIR}word/ {} & {WRITE("#word ");}
#token void TOK_DWORD = /{DIR}dword/ {} & {WRITE("#dword ");}
#token int TOK_ARG = /@[0-9]+/ {$$ = strtol(yytext+1, NULL,16);} & {WRITE("@%i", $$);}

#token void TOK_DB = /{DIR}[dD][bB]/ {}
                   | /[dD][bB]/ {}
                   & {WRITE(".db ");}
#token void TOK_DW = /{DIR}[dD][wW]/ {}
                   | /[dD][wW]/ {}
                   & {WRITE(".dw ");}
#token void TOK_DD = /{DIR}[dD][dD]/ {}
                   | /[dD][dD]/ {}
                   & {WRITE(".dd ");}

*/
