#ifndef ZASM_EXPR_H
#define ZASM_EXPR_H 1

enum
  {
    // used here
    EXPR_OPERATOR,
    EXPR_NUMBER,
    EXPR_NAME,
    // use in link_expr
    EXPR_PAGE,
    EXPR_VALUE
  };

#define EXPR_T(O) ((struct expr_t *)(O))
struct expr_t
{
  // private
  int type;
  union
  {
    struct
    {
      int (*calc)(int arg1, int arg2, int arg3);
      struct expr_t *arg1;
      struct expr_t *arg2;
      struct expr_t *arg3;
    } function;
    int value;
    struct
    {
      char *name;
      char *part;
    } name;
  } value;
};

#include <zasm/alloc.h>
#define EXPR_ALLOC_T(O) ((struct expr_alloc_t *)(O))
ALLOC_DECLARE(expr, ALLOC_DEF_COUNT);

struct expr_t *expr_new(struct expr_alloc_t **alloc);
void expr_fill(struct expr_t *expr);
int expr_calculate(struct expr_t *expr);
void expr_delete(struct expr_t *expr);
void expr_free(struct expr_t *expr);

#endif
