#ifndef ZASM_LINK_ENTRY_H
#define ZASM_LINK_ENTRY_H 1

#include <zasm/hash_table.h>

enum
  {
    LINK_ENTRY_GLOBAL = 0x01,
    LINK_ENTRY_DEFINED = 0x02,
  };

#define LINK_ENTRY_T(O) ((struct link_entry_t *)(O))
struct link_entry_t
{
  // public
  struct hash_entry_t entry;

  // private
  int page;
  int flags;
  struct link_expr_t *expr;
};

#include <zasm/alloc.h>
#define LINK_ENTRY_ALLOC(O) ((struct link_entry_t *)(O))
ALLOC_DECLARE(link_entry, ALLOC_DEF_COUNT);

#include <zasm/link_expr.h>
#include <zasm/link_namespace.h>

struct link_entry_t *link_entry_new(struct link_level_t *level, char *name);
void link_entry_fill(struct link_entry_t *entry, struct link_level_t *level, char *name);
struct link_entry_t *link_entry_copy(struct link_entry_t *original, struct link_level_t *to);
void link_entry_define(struct link_entry_t *entry, struct link_level_t *level, struct expr_t *expr, int addr, int page);
void link_entry_define_global(struct link_entry_t *entry, int page);
void link_entry_set_global(struct link_entry_t *entry);
int link_entry_defined(struct link_entry_t *entry);
int link_entry_global(struct link_entry_t *entry);
void link_entry_delete(struct link_entry_t *entry);
void link_entry_free(struct link_entry_t *entry);

#endif
