#ifndef ZASM_LINK_EXPR_H
#define ZASM_LINK_EXPR_H 1

#define LINK_EXPR_T(O) ((struct link_expr_t *)(O))
struct link_expr_t
{
  // private
  int type;
  union
  {
    struct
    {
      int (*calc)(int arg1, int arg2, int arg3);
      struct link_expr_t *arg1;
      struct link_expr_t *arg2;
      struct link_expr_t *arg3;
    } function;
    struct link_entry_t *entry;
    int value;
  } value;
};

#include <zasm/alloc.h>
#define LINK_EXPR_ALLOC_T(O) ((struct link_expr_alloc_t *)(O))
ALLOC_DECLARE(link_expr, ALLOC_DEF_COUNT);

#include <zasm/link_namespace.h>
#include <zasm/expr.h>
#include <zasm/functions.h>
struct link_expr_t *link_expr_new(struct link_level_t *level);
void link_expr_fill(struct link_expr_t *expr);
struct link_expr_t *link_expr_from_expr(struct link_level_t *level, struct expr_t *expr, int addr, int page);
struct link_expr_t *link_expr_copy(struct link_expr_t *expr, struct link_level_t *to);
void link_expr_simplify(struct link_expr_t *expr);
void link_expr_print_unresolved(struct link_expr_t *expr);
void link_expr_delete(struct link_expr_t *expr);
void link_expr_free(struct link_expr_t *expr);

#endif
