#ifndef ZASM_LINK_LOOKUP_H
#define ZASM_LINK_LOOKUP_H 1

#define LINK_LOOKUP_T(O) ((struct link_lookup_t *)(O))
struct link_lookup_t
{
  int *dest;
  struct link_expr_t *expr;
  struct link_lookup_t *next;
};

#include <zasm/alloc.h>
#define LINK_LOOKUP_ALLOC_T(O) ((struct link_lookup_alloc_t *)(O))
ALLOC_DECLARE(link_lookup, ALLOC_DEF_COUNT);

#include <zasm/link_expr.h>
struct link_lookup_t *link_lookup_new(struct link_level_t *level, struct expr_t *expr, int addr, int page, int *dest);
void link_lookup_fill(struct link_lookup_t *lookup, struct link_level_t *level,
		      struct expr_t *expr, int addr, int page, int *dest);
struct link_lookup_t *link_lookup_new_copy(struct link_level_t *level, struct link_lookup_t *original);
void link_lookup_error_unresolved(struct link_lookup_t *lookup);
void link_lookup_copy(struct link_lookup_t *lookup, struct link_level_t *dest);
void link_lookup_delete(struct link_lookup_t *lookup);
void link_lookup_free(struct link_lookup_t *lookup);

#endif
