#define ZASM_STRING_C 1

#include <zasm/string.h>
#include <zasm/memory.h>
#include <string.h>

char *string_new(char *c_string)
{
  int l = strlen(c_string);
  void *str;
  
  str = malloc(sizeof(int)+(l+1)*sizeof(char));
  str+=sizeof(int);
  string_fill((char *)str, c_string);
  return (char *)str;
}

void string_fill(char *string, char *c_string)
{
  STRING_REFCOUNT(string) = 1;
  strcpy(string, c_string);
}

char *string_copy(char *string)
{
  STRING_REFCOUNT(string)++;
  return string;
}

void string_delete(char *string)
{
  if (string)
    STRING_REFCOUNT(string)--;
}

void string_free(char *string)
{
  void *data;
  if (string)
    {
      string_delete(string);
      if (STRING_REFCOUNT(string) <= 0)
	{
	  data = string;
	  data -= sizeof(int);
	  free(data);
	}
    }
}

